**Veloren** || A flexible game design document.  
===============

**Table of Contents** 

[[_TOC_]]  

**Abstract**
-------------------------------------  

The purpose of this document is to provide guidance for all contributors.
Given the open-source nature of the project, you should be able to work on whatever aspect you like.
However, we must realize that everyone is contributing to the same game.
Everything you add should mesh with the big picture; this document serves to help each team create a cohesive experience.
It also is intended to provide a centralized reference that can be pointed to in order to answer questions about the long-term goals of frequently-requested features.

**On versioning**
--------------------------------------  

Veloren is currently in pre-alpha.
There is currently no consensus on what sets of features would constitute a move to alpha or beta.
As more features get proposed, the scope of our ambitions expand; there's no intended limit to the scope.

**Philosophy**
--------------------------------------  

- **Game design is important and the game design team needs to be restructured so that they are directly involved with the development process.**
- The game design team **should** be composed of people who have had experience with making games and dealing with playerbases. 
- A game designer should be able to give direction on mechanics and judge whether or not something is a bad idea and if it will work in the grand scheme. 
- A game designer's main responsibility is to make sure that the core gameplay loops are as rewarding and fun as possible, while also ensuring that all mechanics are sound and combine with eachother enough to make a cohesive gameplay experience. 
- Given the open-source nature of the project, a game designer should not restrict the freedoms of each respective team; they must simply direct it to the benefit of the player.

**Game Design Document**
===========================================

Each team/person responsible for each section should contribute to each section.
When adding sufficiently-large new features, each team should consult the Game Design team first.
If discussion on Discord/Matrix shifted consensus on a design goal, this index or the relevant RFC should be updated to reflect the new consensus.

Section guidelines:  
- Under Current State, address the current state of the section as it is in the game as a concise summary (include mechanics, etc) Also include major problems.  
- Under Direction, address the direction that the section should be working towards as a concise summary (include mechanics, etc). Present solutions to major problems.
- Under Related RFCs, hyperlink RFCs relevant to the Direction and Current State.
- Do not write your college thesis anywhere. Reserve large, detailed info for RFCs and link them if you need to.

This way, everyone can be aware of what is going on with each aspect of the game's development. A lot of gray area is eliminated and communication is enhanced. Update the document as often as you see fit. Don't forget to consult the Game Design team when thinking about new features.

*Assets & Visual Design*
-------------------------------------------
**Current State:**  

**Direction:**  

**Related RFCs:**  


*Audio*
-------------------------------------------
**Current State:**  

**Direction:**  

**Related RFCs:**  


*Combat*
-------------------------------------------
**Current State:**  

**Direction:**  

**Related RFCs:**  

- [Combat tracking issue](https://gitlab.com/veloren/veloren/-/issues/754)
- [Death system](https://gitlab.com/veloren/rfcs/-/blob/master/open/0004-death-system.md)


*Game Design*
-------------------------------------------
**Current State:**  

**Direction:**  

**Related RFCs:**  

*Pets and Mounts*
-------------------------------------------
**Current State:**  

- Wild animals (mostly prey, not predators, technically `Alignment::Wild`) can be tamed with the "Collar" item to fight for the player.
- The admin command `/spawn` creates mountable NPCs (e.g. `/spawn pet horse`), but the mounting system uses fixed offsets.
- Admin-summonable airships with `/airship` are mountable and can be flown and walked on.
- RtSim airships can be walked on, but not chartered, purchased, mounted, or tamed.

**Direction:**  

- Once mounts use a dynamic offset (e.g. so that you move relative to a horse as it's galloping), it will likely be considered stable enough to add as a "Collar" feature.
- Respawning might be considered for collar-tamed pets, but is controversial and may need a design meeting.
- Airships need their own RFC to be written, but the intent is to have them purchasable and buildable.

**Related RFCs:**  

- [Pet tracking issue](https://gitlab.com/veloren/veloren/-/issues/800)
- [Wiring RFC (for airships)](https://gitlab.com/veloren/rfcs/-/blob/master/open/xxxx-wiring_system.md)


*Rendering/Lighting*
-------------------------------------------
**Current State:**  

**Direction:**  

**Related RFCs:**  


*WorldGen*
-------------------------------------------
**Current State:**  

**Direction:**  

- TODO: summarize site2 refactoring

**Related RFCs:**  


*WorldSim*
-------------------------------------------
**Current State:**  

**Direction:**  

- TODO: describe dynamic econsim & rtsim merchants

**Related RFCs:**  


*Miscellaneous*
-------------------------------------------
**Current State:**  

**Direction:**  

**Related RFCs:**  

